//+------------------------------------------------------------------+
//|                                                     		 BBonRSI |
//|                               Copyright  2006-2011, FXmaster.de |
//|                                      						 www.FXmaster.de |
//|     	programming & support - Alex Sergeev (profy.mql@gmail.com) |
//+------------------------------------------------------------------+
#property copyright "Copyright  2006-2011, Alex Sergeev"
#property link      "profy.mql@gmail.com"

#property indicator_separate_window
#property indicator_buffers 4
#property indicator_minimum 0
#property indicator_maximum 100

#property indicator_color1 SkyBlue
#property indicator_color2 LimeGreen
#property indicator_color3 LimeGreen
#property indicator_color4 LimeGreen
#property indicator_style2 STYLE_DOT

extern int rsiPeriod=14;
extern int rsiPrice=PRICE_CLOSE;
extern int bbPeriod=20;
extern int bbShift=0;
int bbMethod=MODE_SMA;
extern double bbDeviat=2;

double rsi[], ma[], up[], dn[], stdev[];
//------------------------------------------------------------------	init
int init()
{
	int i=0;
	SetIndexBuffer(i, rsi); SetIndexStyle(i, DRAW_LINE); SetIndexLabel(i, "RSI"); i++;
	SetIndexBuffer(i, ma); SetIndexStyle(i, DRAW_LINE); SetIndexLabel(i, "MA"); i++;
	SetIndexBuffer(i, up); SetIndexStyle(i, DRAW_LINE); SetIndexLabel(i, "UP"); i++;
	SetIndexBuffer(i, dn); SetIndexStyle(i, DRAW_LINE); SetIndexLabel(i, "DN"); i++;
	IndicatorBuffers(5);
	SetIndexBuffer(i, stdev); SetIndexStyle(i, DRAW_NONE);
	return(0);
}
//------------------------------------------------------------------	start
int start()
{
	int count=IndicatorCounted(); if (count<0) return; //   
	int lim=Bars-count; if (lim>1) lim=Bars-1; //    1 ,   
	// 1.   RSI
	for (int i=lim; i>=0; i--) rsi[i]=iRSI(Symbol(), Period(), rsiPeriod, rsiPrice, i);
	// 2.    RSI -  (  ), StdDev      
	for (i=lim; i>=0; i--) 
	{
		ma[i]=iMAOnArray(rsi, 0, bbPeriod, bbShift, bbMethod, i); //  
		stdev[i]=iStdDevOnArray(rsi, 0, bbPeriod, bbShift, bbMethod, i); // 
		up[i]=ma[i]+bbDeviat*stdev[i]; //  
		dn[i]=ma[i]-bbDeviat*stdev[i]; //  
	}
	return(0);
}